Subject: Re: [RFC][PATCH v2] git on Mac OS and precomposed unicode

From: Torsten Bögershausen <[email-masked]>
Date: Fri, 13 Jan 2012 22:52:46 +0100

On 01/09/2012 08:52 PM, Junio C Hamano wrote:
[snip]
 >probe_utf8_pathname_composition(path, len);
Done

[snip]

 >and implementation of the function body in compat/darwin.c (Didn't I see a
 >comment on the name of this file, by the way? What was the conclusion of
 > the discussion?).

I renamed the compat/darwin.[ch] into compat/precomposed_utf8.[ch]
>> +{
>> +	int i = 0;
>> +	int first_arg = 0; /* convert everything */
>> +	const char *oldarg;
>> +	char *newarg;
>> +	iconv_t ic_precompose;
>> +
>> +	git_config(precomposed_unicode_config, NULL);
>
> Hmmmmm.  Is it safe to call git_config() this early in the program?  Have
> we determined if we are in a git managed repository and where its $GIT_DIR
> is?
>
According to my understanding, yes:
git_config is called with the custom function precomposed_unicode_config():

git_config(precomposed_unicode_config, NULL);

where
  precomposed_unicode_config()

fishes for the config variable  "core.precomposedunicode" and puts the 
result into
int precomposed_unicode_config.

After that, when precomposed_unicode_config==0, argv_precomposed() will 
return.

  I'll send the V3 RFC/PATCH
/Torsten